#ifndef TYPE_Action 
#define TYPE_Action 
#include "TYPE_Action.h" 
#endif
#ifndef TYPE_Exceptions 
#define TYPE_Exceptions 
#include "TYPE_EXCEPTIONS.h" 
#endif
#ifndef TYPE_SimulatorState 
#define TYPE_SimulatorState 
#include "TYPE_SimulatorState.h" 
#endif
#include "XcD_PACKAGE.h"
#define CompositeName lunarLander
#ifndef CompositeID
#define CompositeID 0
#endif
#ifndef COMPONENT_TYPE_calculation
#define COMPONENT_TYPE_calculation
#include  "COMPONENT_TYPE_calculation.h"
#endif

#ifndef COMPONENT_TYPE_dataStore
#define COMPONENT_TYPE_dataStore
#include  "COMPONENT_TYPE_dataStore.h"
#endif

#ifndef COMPONENT_TYPE_userInterface
#define COMPONENT_TYPE_userInterface
#include  "COMPONENT_TYPE_userInterface.h"
#endif


#ifndef CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_calculation
#define CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_calculation
#include "CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_calculation.h"
#endif
#ifndef CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_dataStore
#define CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_dataStore
#include "CONNECTOR_TYPE_complex_data2calculation_conn1_0_ROLE_dataStore.h"
#endif

#ifndef CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_calculation
#define CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_calculation
#include "CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_calculation.h"
#endif
#ifndef CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_userInterface
#define CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_userInterface
#include "CONNECTOR_TYPE_complex_calculation2userInterface_conn2_0_ROLE_userInterface.h"
#endif

#ifndef CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_userInterface
#define CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_userInterface
#include "CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_userInterface.h"
#endif
#ifndef CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_dataStore
#define CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_dataStore
#include "CONNECTOR_TYPE_complex_userInterface2Data_conn3_0_ROLE_dataStore.h"
#endif


chan CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[1] = [1] of {byte,mtype};
chan CHANNELRES_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[1] = [1] of {byte,mtype,bit,byte};

chan CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[1] = [1] of {byte,mtype};
chan CHANNELRES_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[1] = [1] of {byte,mtype,bit,byte};
chan CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[1] = [1] of {byte,mtype};
chan CHANNELRES_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[1] = [1] of {byte,mtype,bit,byte};

chan CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState[1] = [1] of {byte,mtype,int};
chan CHANNELRES_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState[1] = [1] of {byte,mtype,bit,byte};
chan CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate[1] = [1] of {byte,mtype};
chan CHANNELRES_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate[1] = [1] of {byte,mtype,bit,byte};

#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_calculation_VAR_state COMPONENT_calculation_VAR_state[0]
#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_calculation_VAR_PORT_simState_INDEX COMPONENT_calculation_VAR_PORT_simState_INDEX


#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_calculation_VAR_PORT_data_burnRate_INDEX COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX


#define CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_PORT_data_INDEX COMPONENT_calculation_VAR_PORT_data_INDEX








#define CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_PORT_newData_INDEX COMPONENT_calculation_VAR_PORT_newData_INDEX









#define CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_PORT_data_ui_INDEX COMPONENT_dataStore_VAR_PORT_data_ui_INDEX








#define CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_PORT_data_calc_INDEX COMPONENT_dataStore_VAR_PORT_data_calc_INDEX








#define CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_PORT_newData_INDEX COMPONENT_dataStore_VAR_PORT_newData_INDEX









#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_state COMPONENT_userInterface_VAR_state[0]
#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_PORT_simState_INDEX COMPONENT_userInterface_VAR_PORT_simState_INDEX


#define CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_PORT_data_burnRate_INDEX COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX


#define CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_userInterface_VAR_PORT_data_INDEX COMPONENT_userInterface_VAR_PORT_data_INDEX










//Component Instance : calculation_calc_ins_0
#define Instance 0
#define CompInstanceID calc_ins
chan component_i_blockedChannel(CompositeName, CompositeID,calculation,CompInstanceID,Instance)= [0] of {mtype};
#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_ACTION_notify \
if\
::COMPONENT_calculation_VAR_PORT_simState_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState[0]! _pid,notify,COMPONENT_calculation_VAR_state[0] \
fi

#define CHANNELRES_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState \
atomic{\
CHANNELRES_COMPONENT_calculation_VAR_PORT_simState[Component_i_Port_Num(CompositeName,CompositeID,calculation,CompInstanceID,Instance,simState)]=component_i_blockedChannel(CompositeName,CompositeID,calculation,CompInstanceID,Instance) ;\
COMPONENT_calculation_VAR_PORT_simState_INDEX=0; \
do \
::COMPONENT_calculation_VAR_PORT_simState_INDEX==0->\
CHANNELRES_COMPONENT_calculation_VAR_PORT_simState[COMPONENT_calculation_VAR_PORT_simState_INDEX]=CHANNELRES_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState[0]; \
COMPONENT_calculation_VAR_PORT_simState_INDEX++ \
::else->COMPONENT_calculation_VAR_PORT_simState_INDEX=0; break \
od\
}

#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_ACTION_burnRate \
if\
::COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate[0]! _pid,burnRate \
fi

#define CHANNELRES_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate \
atomic{\
CHANNELRES_COMPONENT_calculation_VAR_PORT_data_burnRate[Component_i_Port_Num(CompositeName,CompositeID,calculation,CompInstanceID,Instance,data_burnRate)]=component_i_blockedChannel(CompositeName,CompositeID,calculation,CompInstanceID,Instance) ;\
COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX=0; \
do \
::COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX==0->\
CHANNELRES_COMPONENT_calculation_VAR_PORT_data_burnRate[COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX]=CHANNELRES_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate[0]; \
COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX++ \
::else->COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX=0; break \
od\
}

#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_fuel \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[0]! _pid,fuel \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_simulationTime \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[0]! _pid,simulationTime \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_velocity \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[0]! _pid,velocity \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_height \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[0]! _pid,height \
fi

#define CHANNELRES_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data \
atomic{\
CHANNELRES_COMPONENT_calculation_VAR_PORT_data[Component_i_Port_Num(CompositeName,CompositeID,calculation,CompInstanceID,Instance,data)]=component_i_blockedChannel(CompositeName,CompositeID,calculation,CompInstanceID,Instance) ;\
COMPONENT_calculation_VAR_PORT_data_INDEX=0; \
do \
::COMPONENT_calculation_VAR_PORT_data_INDEX==0->\
CHANNELRES_COMPONENT_calculation_VAR_PORT_data[COMPONENT_calculation_VAR_PORT_data_INDEX]=CHANNELRES_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc[0]; \
COMPONENT_calculation_VAR_PORT_data_INDEX++ \
::else->COMPONENT_calculation_VAR_PORT_data_INDEX=0; break \
od\
}



#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_NUM  1 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_NUM  1 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_NUM  1 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_NUM  1 

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_ACTION_notify_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_simState_ACTION_notify_PRE && (COMPONENT_calculation_VAR_PORT_simState_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_calculation_PORTVAR_simState_ACTION_notify_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_ACTION_burnRate_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_data_burnRate_ACTION_burnRate_PRE && (COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_calculation_PORTVAR_data_burnRate_ACTION_burnRate_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_fuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_data_ACTION_fuel_PRE && (COMPONENT_calculation_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_data_ACTION_fuel_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_simulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_data_ACTION_simulationTime_PRE && (COMPONENT_calculation_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_data_ACTION_simulationTime_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_velocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_data_ACTION_velocity_PRE && (COMPONENT_calculation_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_data_ACTION_velocity_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_height_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_data_ACTION_height_PRE && (COMPONENT_calculation_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_data_ACTION_height_PRE: true) 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newSimulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_newData_ACTION_newSimulationTime_PRE && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newSimulationTime_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newSimulationTime_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newSimulationTime_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newFuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_newData_ACTION_newFuel_PRE && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newFuel_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newFuel_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newFuel_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newVelocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_newData_ACTION_newVelocity_PRE && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newVelocity_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newVelocity_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newVelocity_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newHeight_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_calculation_PORT_newData_ACTION_newHeight_PRE && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newHeight_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newHeight_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_calculation_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_PORTVAR_newData_ACTION_newHeight_PRE_RESPONSE: true) 
 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_CONNECTIONS 1


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_SUMCONNECTIONS \
lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_CONNECTIONS 
#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_NUMOFCONNECTIONS \
(\
COMPONENT_calculation_VAR_PORT_newData_INDEX==0->lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_CONNECTIONS :0)\




#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_ACTION_notify_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_simState_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_ACTION_burnRate_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_data_burnRate_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_fuel_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_fuel_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_fuel_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_simulationTime_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_simulationTime_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_simulationTime_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_velocity_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_velocity_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_velocity_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_height_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_ACTION_height_ROLE_DATAUPDATE() \
if\
::COMPONENT_calculation_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_data_0_ACTION_height_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newSimulationTime_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newSimulationTime_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newFuel_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newFuel_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newVelocity_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newVelocity_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newHeight_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[0];\
true

#define lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_ACTION_newHeight_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_calculation_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define COMPONENT_calculation_calc_ins_0_ROLE_DATA() \
\
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess) CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[1]=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess) PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess[1])=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_dataOpInProcess);\ 
bool CONNECTOR_complex_data2calculation_conn1_0_ROLE_calculation_VAR_VALUEEXIST[1];\


c_code { 
int  Component_i_port_offsetArray(CompositeName,CompositeID,calculation,CompInstanceID,0,newData)[Component_i_Port_Num(CompositeName,CompositeID,calculation,CompInstanceID,0,newData)];
}


#define lunarLander_0_COMPONENT_calculation_calc_ins_0_ARRAY_INITIALISATIONS() \
c_code { \ 
Component_i_port_offsetArray(CompositeName,CompositeID,calculation,CompInstanceID,0,newData)[0] = 0;\
} 

#define XX lunarLander
#include "COMPONENT_TYPE_calculation_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 

//Component Instance : dataStore_data_ins_0
#define Instance 0
#define CompInstanceID data_ins
chan component_i_blockedChannel(CompositeName, CompositeID,dataStore,CompInstanceID,Instance)= [0] of {mtype};
#define CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newSimulationTime \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[0]! _pid,newSimulationTime \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newFuel \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[0]! _pid,newFuel \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newVelocity \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[0]! _pid,newVelocity \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newHeight \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[0]! _pid,newHeight \
fi

#define CHANNELRES_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData \
atomic{\
CHANNELRES_COMPONENT_dataStore_VAR_PORT_newData[Component_i_Port_Num(CompositeName,CompositeID,dataStore,CompInstanceID,Instance,newData)]=component_i_blockedChannel(CompositeName,CompositeID,dataStore,CompInstanceID,Instance) ;\
COMPONENT_dataStore_VAR_PORT_newData_INDEX=0; \
do \
::COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->\
CHANNELRES_COMPONENT_dataStore_VAR_PORT_newData[COMPONENT_dataStore_VAR_PORT_newData_INDEX]=CHANNELRES_lunarLander_0_COMPONENT_calculation_calc_ins_0_PORT_newData[0]; \
COMPONENT_dataStore_VAR_PORT_newData_INDEX++ \
::else->COMPONENT_dataStore_VAR_PORT_newData_INDEX=0; break \
od\
}



#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_NUM  1 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_NUM  1 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_NUM  1 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_simulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_ui_ACTION_simulationTime_PRE && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_simulationTime_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_simulationTime_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_simulationTime_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_fuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_ui_ACTION_fuel_PRE && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_fuel_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_fuel_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_fuel_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_velocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_ui_ACTION_velocity_PRE && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_velocity_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_velocity_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_velocity_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_height_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_ui_ACTION_height_PRE && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_height_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_height_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_PORTVAR_data_ui_ACTION_height_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_simulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_calc_ACTION_simulationTime_PRE && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_simulationTime_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_simulationTime_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_simulationTime_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_fuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_calc_ACTION_fuel_PRE && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_fuel_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_fuel_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_fuel_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_velocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_calc_ACTION_velocity_PRE && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_velocity_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_velocity_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_velocity_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_height_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_data_calc_ACTION_height_PRE && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_height_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_height_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_data_calc_ACTION_height_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newSimulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_newData_ACTION_newSimulationTime_PRE && (COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_newData_ACTION_newSimulationTime_PRE: true) 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newFuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_newData_ACTION_newFuel_PRE && (COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_newData_ACTION_newFuel_PRE: true) 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newVelocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_newData_ACTION_newVelocity_PRE && (COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_newData_ACTION_newVelocity_PRE: true) 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newHeight_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_dataStore_PORT_newData_ACTION_newHeight_PRE && (COMPONENT_dataStore_VAR_PORT_newData_INDEX==0->ICONTRACT_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_PORTVAR_newData_ACTION_newHeight_PRE: true) 

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_CONNECTIONS 1
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_CONNECTIONS 1


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_SUMCONNECTIONS \
lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_CONNECTIONS 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_NUMOFCONNECTIONS \
(\
COMPONENT_dataStore_VAR_PORT_data_ui_INDEX==0->lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_CONNECTIONS :0)\


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_SUMCONNECTIONS \
lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_CONNECTIONS 
#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_NUMOFCONNECTIONS \
(\
COMPONENT_dataStore_VAR_PORT_data_calc_INDEX==0->lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_CONNECTIONS :0)\




#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[0]=false;\
\
 \
 PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[0])=CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[0]=false;\
\
 \
 PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[0])=CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[0]=false;\
\
 \
 PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[0])=CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[0]=false;\
\
 \
 PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[0])=CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_ui_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui_0_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_simulationTime_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_simulationTime_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_fuel_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_fuel_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_velocity_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_velocity_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_height_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0]=false;\
\
 \
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_dataStore_VAR_PORT_data_calc_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_calc_0_ACTION_height_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newSimulationTime_ROLE_DATAUPDATE() \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newSimulationTime_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newFuel_ROLE_DATAUPDATE() \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newFuel_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newVelocity_ROLE_DATAUPDATE() \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newVelocity_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE() \
CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0]=true;\
\
\
 PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0])=CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[0];\
true

#define lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_ACTION_newHeight_ROLE_DATAUPDATE() \
if\
::COMPONENT_dataStore_VAR_PORT_newData_INDEX == 0 -> \
  lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_newData_0_ACTION_newHeight_ROLE_DATAUPDATE() \
fi; 


#define COMPONENT_dataStore_data_ins_0_ROLE_DATA() \
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI) CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[1]=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI) Race_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[1]; \ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI) PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI[1])=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_simTimeObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI) CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[1]=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI) Race_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[1]; \ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI) PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI[1])=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_fuelObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI) CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[1]=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI) Race_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[1]; \ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI) PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI[1])=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_velocityObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI) CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[1]=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI);\ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI) Race_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[1]; \ 
TypeOf(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI) PRE(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI[1])=InitialValue(CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_heightObtainableUI);\ 
bool CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_dataStore_VAR_VALUEEXIST[1];\
\
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable) CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[1]=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable) Race_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[1]; \ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable) PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable[1])=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_simTimeObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable) CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[1]=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable) Race_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[1]; \ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable) PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable[1])=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_fuelObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable) CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[1]=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable) Race_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[1]; \ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable) PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable[1])=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_velocityObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable) CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[1]=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable);\ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable) Race_CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[1]; \ 
TypeOf(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable) PRE(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable[1])=InitialValue(CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_heightObtainable);\ 
bool CONNECTOR_complex_data2calculation_conn1_0_ROLE_dataStore_VAR_VALUEEXIST[1];\


c_code { 
int  Component_i_port_offsetArray(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_ui)[Component_i_Port_Num(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_ui)];
int  Component_i_port_offsetArray(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_calc)[Component_i_Port_Num(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_calc)];
}


#define lunarLander_0_COMPONENT_dataStore_data_ins_0_ARRAY_INITIALISATIONS() \
c_code { \ 
Component_i_port_offsetArray(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_ui)[0] = 0;\
Component_i_port_offsetArray(CompositeName,CompositeID,dataStore,CompInstanceID,0,data_calc)[0] = 0;\
} 

#define XX lunarLander
#include "COMPONENT_TYPE_dataStore_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 

//Component Instance : userInterface_ui_ins_0
#define Instance 0
#define CompInstanceID ui_ins
chan component_i_blockedChannel(CompositeName, CompositeID,userInterface,CompInstanceID,Instance)= [0] of {mtype};
#define CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_simulationTime \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[0]! _pid,simulationTime \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_fuel \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[0]! _pid,fuel \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_velocity \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[0]! _pid,velocity \
fi

#define CHANNELREQ_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_height \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX==0->\
CHANNELREQ_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[0]! _pid,height \
fi

#define CHANNELRES_lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data \
atomic{\
CHANNELRES_COMPONENT_userInterface_VAR_PORT_data[Component_i_Port_Num(CompositeName,CompositeID,userInterface,CompInstanceID,Instance,data)]=component_i_blockedChannel(CompositeName,CompositeID,userInterface,CompInstanceID,Instance) ;\
COMPONENT_userInterface_VAR_PORT_data_INDEX=0; \
do \
::COMPONENT_userInterface_VAR_PORT_data_INDEX==0->\
CHANNELRES_COMPONENT_userInterface_VAR_PORT_data[COMPONENT_userInterface_VAR_PORT_data_INDEX]=CHANNELRES_lunarLander_0_COMPONENT_dataStore_data_ins_0_PORT_data_ui[0]; \
COMPONENT_userInterface_VAR_PORT_data_INDEX++ \
::else->COMPONENT_userInterface_VAR_PORT_data_INDEX=0; break \
od\
}


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PARAM_BurnRate 0

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_NUM  1 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_NUM  1 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_NUM  1 

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_ACTION_notify_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_simState_ACTION_notify_PRE && (COMPONENT_userInterface_VAR_PORT_simState_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_PORTVAR_simState_ACTION_notify_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_ACTION_notify_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_userInterface_VAR_PORT_simState_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_PORTVAR_simState_ACTION_notify_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_ACTION_burnRate_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_data_burnRate_ACTION_burnRate_PRE && (COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_PORTVAR_data_burnRate_ACTION_burnRate_PRE_REQUEST: true) 

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_ACTION_burnRate_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX==0->ICONTRACT_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_PORTVAR_data_burnRate_ACTION_burnRate_PRE_RESPONSE: true) 
 #define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_simulationTime_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_data_ACTION_simulationTime_PRE && (COMPONENT_userInterface_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_userInterface_PORTVAR_data_ACTION_simulationTime_PRE: true) 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_fuel_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_data_ACTION_fuel_PRE && (COMPONENT_userInterface_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_userInterface_PORTVAR_data_ACTION_fuel_PRE: true) 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_velocity_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_data_ACTION_velocity_PRE && (COMPONENT_userInterface_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_userInterface_PORTVAR_data_ACTION_velocity_PRE: true) 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_height_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_userInterface_PORT_data_ACTION_height_PRE && (COMPONENT_userInterface_VAR_PORT_data_INDEX==0->ICONTRACT_CONNECTOR_complex_userInterface2Data_conn3_0_ROLE_userInterface_PORTVAR_data_ACTION_height_PRE: true) 

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_CONNECTIONS 1
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_CONNECTIONS 1


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_SUMCONNECTIONS \
lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_CONNECTIONS 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_NUMOFCONNECTIONS \
(\
COMPONENT_userInterface_VAR_PORT_simState_INDEX==0->lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_CONNECTIONS :0)\


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_SUMCONNECTIONS \
lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_CONNECTIONS 
#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_NUMOFCONNECTIONS \
(\
COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX==0->lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_CONNECTIONS :0)\




#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_ACTION_notify_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_userInterface_VAR_PORT_simState_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE_RESPONSE() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_ACTION_notify_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_userInterface_VAR_PORT_simState_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_simState_0_ACTION_notify_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE_REQUEST() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_ACTION_burnRate_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE_RESPONSE() \
true;CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[0]=true;\
\
 \
 PRE(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[0])=CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[0];\
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_ACTION_burnRate_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_userInterface_VAR_PORT_data_burnRate_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_burnRate_0_ACTION_burnRate_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_simulationTime_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_simulationTime_ROLE_DATAUPDATE() \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_simulationTime_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_fuel_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_fuel_ROLE_DATAUPDATE() \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_fuel_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_velocity_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_velocity_ROLE_DATAUPDATE() \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_velocity_ROLE_DATAUPDATE() \
fi; 


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_height_ROLE_DATAUPDATE() \
true

#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_ACTION_height_ROLE_DATAUPDATE() \
if\
::COMPONENT_userInterface_VAR_PORT_data_INDEX == 0 -> \
  lunarLander_0_COMPONENT_userInterface_ui_ins_0_PORT_data_0_ACTION_height_ROLE_DATAUPDATE() \
fi; 


#define COMPONENT_userInterface_ui_ins_0_ROLE_DATA() \
TypeOf(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent) CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[1]=InitialValue(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent);\ 
TypeOf(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent) Race_CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[1]; \ 
TypeOf(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent) PRE(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent[1])=InitialValue(CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_burnRateSent);\ 
bool CONNECTOR_complex_calculation2userInterface_conn2_0_ROLE_userInterface_VAR_VALUEEXIST[1];\
\


c_code { 
int  Component_i_port_offsetArray(CompositeName,CompositeID,userInterface,CompInstanceID,0,simState)[Component_i_Port_Num(CompositeName,CompositeID,userInterface,CompInstanceID,0,simState)];
int  Component_i_port_offsetArray(CompositeName,CompositeID,userInterface,CompInstanceID,0,data_burnRate)[Component_i_Port_Num(CompositeName,CompositeID,userInterface,CompInstanceID,0,data_burnRate)];
}


#define lunarLander_0_COMPONENT_userInterface_ui_ins_0_ARRAY_INITIALISATIONS() \
c_code { \ 
Component_i_port_offsetArray(CompositeName,CompositeID,userInterface,CompInstanceID,0,simState)[0] = 0;\
Component_i_port_offsetArray(CompositeName,CompositeID,userInterface,CompInstanceID,0,data_burnRate)[0] = 0;\
} 

#define XX lunarLander
#include "COMPONENT_TYPE_userInterface_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 
